package WeddingGrid;

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Scanner;

/*IO class to deal with reading from csv format 
 * 
 */


public class CSVHandler {
	
	private String path;
	private FileWriter fw;
	private Scanner sc;
	private Object[] fieldTitles;
	
	public CSVHandler() {
		
	}

	public CSVHandler(String path) {
		this.path = path;
	}
	
	public void openFile(boolean append) throws Exception {
		fw = new FileWriter(path, append);
		sc = new Scanner(new File(path));
	}
	
	public void resetFile() {
		try {
			openFile(false);
			write(fieldTitles);
			closeFile();
		} catch (Exception e) {}
	}
	
	public void setPath(String path) {
		this.path = path;
	}
	
	public String toCSVField(Object... ar) {
		String subString = "\"";
		for (int i = 0; i < ar.length; i++) {
			if (i > 0) subString = subString.concat(", ");
			subString = subString.concat(ar[i].toString());
		}
		subString = subString.concat("\"");
		
		return subString;
	}
	
	public String toCSV(Object... ar) {
		String finalString = "";
		
		for (int i = 0; i < ar.length; i++) {
			if (i > 0) finalString = finalString.concat(",");
			finalString = finalString.concat(ar[i].toString());
		}
		
		return finalString;
	}
	
	public void append(Object... ar) {
		try {
			fw.append(toCSV(ar) + System.getProperty("line.separator"));
		} catch (Exception e) {System.out.println("w"); e.printStackTrace();}
	}
	
	public void write(Object... ar) {
		try {
			fw.write(toCSV(ar) + System.getProperty("line.separator"));
		} catch (Exception e) {System.out.println("w"); e.printStackTrace();}
	}
	
	public void writeFieldTitles(Object... ar) {
		fieldTitles = ar;
		write(ar);
	}
	
	public String[][] read() {
		ArrayList<String[]> inputList = new ArrayList<String[]>();
		while (sc.hasNext()) {
			String str = sc.nextLine();
			inputList.add(str.split(","));
		}
		
		return inputList.toArray(new String[1][1]);
	}
	
	public void closeFile() throws Exception {
		fw.flush();
		fw.close();
		sc.close();
	}
}
