package WeddingGrid;

import java.io.FileWriter;

public class CSVWriter {
	
	/*IO class to deal with writing to csv format 
	 * 
	*/
	
	private String path;
	private FileWriter fw;
	private Object[] fieldTitles;

	public CSVWriter(String path) {
		this.path = path;
	}
	
	public void openFile(boolean append) {
		try {
			fw = new FileWriter(path, append);
		} catch (Exception e) { System.out.println("o");}
	}
	
	public void resetFile() {
		openFile(false);
		write(fieldTitles);
		closeFile();
	}
	
	public void setPath(String path) {
		this.path = path;
	}
	
	public String toCSVField(Object... ar) {
		String subString = "\"";
		for (int i = 0; i < ar.length; i++) {
			if (i > 0) subString = subString.concat(", ");
			subString = subString.concat(ar[i].toString());
		}
		subString = subString.concat("\"");
		
		return subString;
	}
	
	public String toCSV(Object... ar) {
		String finalString = "";
		
		for (int i = 0; i < ar.length; i++) {
			if (i > 0) finalString = finalString.concat(",");
			finalString = finalString.concat(ar[i].toString());
		}
		
		return finalString;
	}
	
	public void append(Object... ar) {
		try {
			fw.append(toCSV(ar) + System.getProperty("line.separator"));
		} catch (Exception e) {System.out.println("w");}
	}
	
	public void write(Object... ar) {
		try {
			fw.write(toCSV(ar) + System.getProperty("line.separator"));
		} catch (Exception e) {System.out.println("w");}
	}
	
	public void writeFieldTitles(Object... ar) {
		fieldTitles = ar;
		write(ar);
	}
	
	public void closeFile() {
		try {
			fw.flush();
			fw.close();
		} catch (Exception e) {System.out.println("c");}
	}
}
